unit LegendTestMain;

interface

uses
  Windows, Messages, SysUtils, Variants, Classes, Graphics, Controls, Forms,
  Dialogs, TeeGDIPlus, ExtCtrls, TeeProcs, TeEngine, Chart, DBChart, Series,
  StdCtrls, DB, buttons,frmTimer,frmChart;

const
  HIGHLIGHT_WIDTH = 2;
  HIGHLIGHT_PSIZE = 2;

type
  TForm1 = class(TForm)
    DBChart1: TDBChart;
    Button1: TButton;
    Button2: TButton;
    SpeedButton3: TSpeedButton;
    Panel1: TPanel;
    Panel2: TPanel;
    Button4: TButton;
    procedure LoadData(Sender: TObject);
    procedure ClearData(Sender: TObject);
    procedure FormCreate(Sender: TObject);
    procedure MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
    procedure ClearHighlightedSeries(aChart: TDBChart);
    function RGBA(const r,g,b,a:Integer):TColor;
    procedure SuppressDups(Sender: TObject);
    procedure UndockGraph(Sender: TObject);

  private
    { Private declarations }
    fAntClickedIndex: integer;
    fSavedIndexL: integer;
    fSavedWidth: integer;
    fSavedIndexP: integer;
    fSavedHorizSize: integer;
    fSavedVertSize: integer;
    fSkipRun1WHP: boolean;
    fSkipRun2Temp: boolean;
    fSuppressDups: boolean;
    fNDep: integer;
    formTimer: TformTimer;
    bSingleSeries: boolean;
    formChart: TformChart;

  public
    { Public declarations }
  end;

var
  Form1: TForm1;
   // Define dynamic array
  MA0 : Array of Array of integer;  // Multi-dimension array
  MA1 : Array of Array of integer;  // Multi-dimension array
  MA2: Array of Array of integer;  // Multi-dimension array
  MA3 : Array of Array of integer;  // Multi-dimension array

implementation

{$R *.dfm}

procedure TForm1.FormCreate(Sender: TObject);
var
  i,j : Integer;

begin
  formChart := TformChart.Create(Screen.ActiveForm);
  formChart.Visible := False;
  formTimer := TformTimer.Create(nil);
   // Set the length of the 1st dimension of the multi-dim array
  SetLength(MA0,4);
  SetLength(MA0[0], 10);
  SetLength(MA0[1], 10);
  SetLength(MA0[2], 10);
  SetLength(MA0[3], 10);
  SetLength(MA1,4);
  SetLength(MA1[0], 9);
  SetLength(MA1[1], 9);
  SetLength(MA1[2], 9);
  SetLength(MA1[3], 9);
  SetLength(MA2,4);
  SetLength(MA2[0], 8);
  SetLength(MA2[1], 8);
  SetLength(MA2[2], 8);
  SetLength(MA2[3], 8);
  SetLength(MA3,4);
  SetLength(MA3[0], 7);
  SetLength(MA3[1], 7);
  SetLength(MA3[2], 7);
  SetLength(MA3[3], 7);

  fNDep := 3;

   // Set and show all elements of this array
   for j := 0 to High(MA0[0]) do
   begin
     MA0[0,j] := 80*j;
     MA0[1,j] := Trunc(-(80*j)*(80*j)*0.00035 + 80*j*0.5) + 90 + Random(10);
     MA0[2,j] := 8*j + Random(5);
     MA0[3,j] := 60 + 40*j + Random(1);
   end;

   for j := 0 to High(MA1[0]) do
   begin
     MA1[0,j] := 90*j;
     MA1[1,j] := Trunc(-(80*j)*(80*j)*0.00036 + 100*j*0.5) + 60 + Random(10);
     MA1[2,j] := 10*j + Random(5);
     MA1[3,j] := 40 +50*j+Random(1);
   end;

   for j := 0 to High(MA2[0]) do
   begin
     MA2[0,j] := 100*j;
     MA2[1,j] := Trunc(-(90*j)*(90*j)*0.0003 + 90*j*0.6) + 80 + Random(10);
     MA2[2,j] := 12*j + Random(5);
     MA2[3,j] := 20 +60*j+Random(1);
   end;

 end;

procedure TForm1.ClearData(Sender: TObject);
begin
  DBChart1.RemoveAllSeries;
end;

procedure TForm1.LoadData(Sender: TObject);
var
  i,j: integer;
  Line00,Line01,Line02,Line10,Line11,Line12: TLineSeries;
  Line20,Line21,Line22: TLineSeries;
  Fast00,Fast01,Fast02,Fast10,Fast11,Fast12: TFastLineSeries;
  Fast20,Fast21,Fast22: TFastLineSeries;
  Point00,Point01,Point02,Point10,Point11,Point12: TPointSeries;
  Point20,Point21,Point22: TPointSeries;
  SColor0,SColor1,SColor2: TColor;
  MsgT, MsgW, MsgP: string;

begin
  ClearData(Sender);

  SColor0 := RGBA(255,0,0,0);
  SColor1 := RGBA(0,255,0,0);
  SColor2 := RGBA(0,0,255,0);

  if fSuppressDups then
  begin
    MsgT := '';
    MsgW := '';
    MsgP := '';
  end
  else
  begin
    MsgT := ' Temperature';
    MsgW := ' WHP';
    MsgP := ' Pressure';
  end;

  Line00 := DBChart1.AddSeries(TLineSeries) as TLineSeries;
  Line00.Title := 'Run 1' + MsgT;
  Line00.SeriesColor := SColor0;
  Fast00 := DBChart1.AddSeries(TFastLineSeries) as TFastLineSeries;
  Fast00.SeriesColor := SColor0;
  Point00 := DBChart1.AddSeries(TPointSeries) as TPointSeries;
  Point00.Pointer.Color := SColor0;

// define each series even if no data
  if not bSingleSeries then
  begin
    Line01 := DBChart1.AddSeries(TLineSeries) as TLineSeries;
    Line01.Title := 'Run 1' + MsgW;
    Line01.SeriesColor := SColor1;
    Fast01 := DBChart1.AddSeries(TFastLineSeries) as TFastLineSeries;
    Fast01.SeriesColor := SColor1;
    Point01 := DBChart1.AddSeries(TPointSeries) as TPointSeries;
    Point01.Pointer.Color := SColor0;

    Line02 := DBChart1.AddSeries(TLineSeries) as TLineSeries;
    Line02.Title := 'Run 1' + MsgP;
    Line02.SeriesColor := SColor2;
    Fast02 := DBChart1.AddSeries(TFastLineSeries) as TFastLineSeries;
    Fast02.SeriesColor := SColor2;
    Point02 := DBChart1.AddSeries(TPointSeries) as TPointSeries;
    Point02.Pointer.Color := SColor0;

    Line10 := DBChart1.AddSeries(TLineSeries) as TLineSeries;
    Line10.Title := 'Run 2' + MsgT;
    Line10.SeriesColor := SColor0;
    Fast10 := DBChart1.AddSeries(TFastLineSeries) as TFastLineSeries;
    Fast10.SeriesColor := SColor0;
    Point10 := DBChart1.AddSeries(TPointSeries) as TPointSeries;
    Point10.Pointer.Color := sColor1;

    Line11 := DBChart1.AddSeries(TLineSeries) as TLineSeries;
    Line11.Title := 'Run 2' + MsgW;
    Line11.SeriesColor := SColor1;
    Fast11 := DBChart1.AddSeries(TFastLineSeries) as TFastLineSeries;
    Fast11.SeriesColor := SColor1;
    Point11 := DBChart1.AddSeries(TPointSeries) as TPointSeries;
    Point11.Pointer.Color := SColor1;

    Line12 := DBChart1.AddSeries(TLineSeries) as TLineSeries;
    Line12.Title := 'Run 2' + MsgP;
    Line12.SeriesColor := SColor2;
    Fast12 := DBChart1.AddSeries(TFastLineSeries) as TFastLineSeries;
    Fast12.SeriesColor := SColor2;
    Point12 := DBChart1.AddSeries(TPointSeries) as TPointSeries;
    Point12.Pointer.Color := SColor1;

// define each series even if no data
    Line20 := DBChart1.AddSeries(TLineSeries) as TLineSeries;
    Line20.Title := 'Run 3' + MsgT;
    Line20.SeriesColor := SColor0;
    Fast20 := DBChart1.AddSeries(TFastLineSeries) as TFastLineSeries;
    Fast20.SeriesColor := SColor0;
    Point20 := DBChart1.AddSeries(TPointSeries) as TPointSeries;
    Point20.Pointer.Color := SColor2;

    Line21 := DBChart1.AddSeries(TLineSeries) as TLineSeries;
    Line21.Title := 'Run 3' + MsgW;
    Line21.SeriesColor := SColor1;
    Fast21 := DBChart1.AddSeries(TFastLineSeries) as TFastLineSeries;
    Fast21.SeriesColor := SColor1;
    Point21 := DBChart1.AddSeries(TPointSeries) as TPointSeries;
    Point21.Pointer.Color := SColor2;

    Line22 := DBChart1.AddSeries(TLineSeries) as TLineSeries;
    Line22.Title := 'Run 3' + MsgP;
    Line22.SeriesColor := SColor2;
    Fast22 := DBChart1.AddSeries(TFastLineSeries) as TFastLineSeries;
    Fast22.SeriesColor := SColor2;
    Point22 := DBChart1.AddSeries(TPointSeries) as TPointSeries;
    Point22.Pointer.Color := SColor2;
  end;

  for j := 0 to High(MA0[0]) do
  begin
    Line00.AddXY(MA0[1,j],MA0[0,j]);
    Fast00.AddXY(MA0[1,j],MA0[0,j]);
    if (j mod 2 = 0) then
      Point00.AddXY(MA0[1,j],MA0[0,j]);

    if not bSingleSeries then
    begin
      if not fSkipRun1WHP then
      begin
        Line01.AddXY(MA0[2,j],MA0[0,j]);
        Fast01.AddXY(MA0[2,j],MA0[0,j]);
        if (j mod 2 = 0) then
          Point01.AddXY(MA0[2,j],MA0[0,j]);
      end;
      Line02.AddXY(MA0[3,j],MA0[0,j]);
      Fast02.AddXY(MA0[3,j],MA0[0,j]);
      if (j mod 2 = 0) then
        Point02.AddXY(MA0[3,j],MA0[0,j]);
    end;
  end;

  if not bSingleSeries then
  begin
    for j := 0 to High(MA1[0]) do
    begin
      if not fSkipRun2Temp then
      begin
        Line10.AddXY(MA1[1,j],MA1[0,j]);
        Fast10.AddXY(MA1[1,j],MA1[0,j]);
        if (j mod 2 = 0) then
          Point10.AddXY(MA1[1,j],MA1[0,j]);
      end;
      Line11.AddXY(MA1[2,j],MA1[0,j]);
      Fast11.AddXY(MA1[2,j],MA1[0,j]);
      if (j mod 2 = 0) then
        Point11.AddXY(MA1[2,j],MA1[0,j]);
      Line12.AddXY(MA1[3,j],MA1[0,j]);
      Fast12.AddXY(MA1[3,j],MA1[0,j]);
      if (j mod 2 = 0) then
        Point12.AddXY(MA1[3,j],MA1[0,j]);
    end;

    for j := 0 to High(MA2[0]) do
    begin
      Line20.AddXY(MA2[1,j],MA2[0,j]);
      Fast20.AddXY(MA2[1,j],MA2[0,j]);
      if (j mod 2 = 0) then
        Point20.AddXY(MA2[1,j],MA2[0,j]);
      Line21.AddXY(MA2[2,j],MA2[0,j]);
      Fast21.AddXY(MA2[2,j],MA2[0,j]);
      if (j mod 2 = 0) then
        Point21.AddXY(MA2[2,j],MA2[0,j]);
      Line22.AddXY(MA2[3,j],MA2[0,j]);
      Fast22.AddXY(MA2[3,j],MA2[0,j]);
      if (j mod 2 = 0) then
        Point22.AddXY(MA2[3,j],MA2[0,j]);
    end;
  end;

  for I := 0 to DBChart1.SeriesCount - 1 do
  begin
    if (i mod 9 in [0,1,2]) then
      DBChart1.Series[i].HorizAxis := aBottomAxis
    else
      DBChart1.Series[i].HorizAxis := aTopAxis;

    if (DBChart1.Series[i] is TFastLineSeries)
      or (DBChart1.Series[i] is TPointSeries) then
      DBChart1.Series[i].ShowInLegend := false;
    if fSuppressDups then
    begin
      if (i mod (3*fNDep) <> 0) then
        DBChart1.Series[i].ShowInLegend := false;
    end;
  end;
end;

procedure TForm1.MouseMove(Sender: TObject; Shift: TShiftState; X, Y: Integer);
var
  LChart: TDBChart;
  LSeriesL,LSeriesP: TChartSeries;
  LClickedIndex,LSeriesCount,LVisCount,LInVisCount,i,LNDep: integer;
  LSavedL, LSavedP: boolean;


begin
  Assert(Sender is TDBChart);
  lChart := DBChart1;

// assume at least one live series in each dataset?????
  lClickedIndex:= lChart.Legend.Clicked(X,Y);
//  if fSuppressDups then formTimer.ShowTimerWindow(IntToStr(lClickedIndex),500);
  if (lClickedIndex > -1) then
  begin
    FAntClickedIndex := lClickedIndex;
    ClearHighlightedSeries(lChart);

    if fSuppressDups then
    begin
      LSavedL := False;
      LSavedP := False;

      for i := 0 to fNDep - 1 do
      begin
        lSeriesL := lChart[lClickedIndex*3*fNDep + 3*i + 1]; // as 3 series for each curve
        if assigned(lSeriesL) then
        begin
          if (lSeriesL is TFastLineSeries) then
            if (LseriesL.XValues.Count > 0) then

          begin
            if not LSavedL then
            begin
              FSavedIndexL := lClickedIndex*3*fNDep + 3*i + 1;
              FSavedWidth := lSeriesL.Pen.Width;
              LSavedL := True;
            end;
            TFastLineSeries(lSeriesL).Pen.Width := TFastLineSeries(lSeriesL).Pen.Width + HIGHLIGHT_WIDTH;
          end;
        end;

        lSeriesP := lChart[lClickedIndex*3*fNDep + 3*i + 2]; // as 3 series for each curve
        if assigned(lSeriesP) then
        begin
          if (lSeriesP is TPointSeries) and (lSeriesP.XValues.Count > 0) then
          begin
            if not LSavedP then
            begin
              FSavedIndexP := lClickedIndex*3*fNDep + 3*i + 2;
              FSavedHorizSize := TPointSeries(lSeriesP).Pointer.HorizSize;
              FSavedVertSize := TPointSeries(lSeriesP).Pointer.VertSize;
              LSavedP := True;
            end;
            TPointSeries(lSeriesP).Pointer.HorizSize :=
              TPointSeries(lSeriesP).Pointer.HorizSize + HIGHLIGHT_PSIZE;
            TPointSeries(lSeriesP).Pointer.VertSize :=
              TPointSeries(lSeriesP).Pointer.VertSize + HIGHLIGHT_PSIZE;
          end;
        end;
      end;
    end
    else  // not SuppressDups
    begin
// determine visible and invisible count
      LSeriesCount := LChart.SeriesCount;
      lVisCount := 0;
      lInvisCount := 0;
      for i := 0 to Trunc((LSeriesCount)/3) - 1 do
      begin
        if lChart[(3*i+1)].Visible then
        begin
          inc(lVisCount);  // count visible
          if (lVisCount = lClickedIndex + 1) then
// found the corresponding visible series so stop
            break;
        end
        else
          inc(lInVisCount); // count invisibles to that point
      end;

      if ((LClickedIndex+1+LInvisCount)*3 <= LSeriesCount)  then
      begin
        lSeriesL := lChart[(lInvisCount+lClickedIndex)*3+1]; // as 3 series for each curve
        if assigned(lSeriesL) then
          if (lSeriesL is TFastLineSeries) then
          begin
            FSavedIndexL := (lInvisCount+lClickedIndex)*3 + 1;
            FSavedWidth := lSeriesL.Pen.Width;
            TLineSeries(lSeriesL).Pen.Width := TLineSeries(lSeriesL).Pen.Width + HIGHLIGHT_WIDTH;
          end;

        lSeriesP := lChart[(lInvisCount+lClickedIndex)*3+2]; // as 3 series for each curve
        if assigned(lSeriesP) then
          if (lSeriesP is TPointSeries) then
          begin
            FSavedIndexP := (lInvisCount+lClickedIndex)*3 + 2;
            FSavedHorizSize := TPointSeries(lSeriesP).Pointer.HorizSize;
            FSavedVertSize := TPointSeries(lSeriesP).Pointer.VertSize;
            TPointSeries(lSeriesP).Pointer.HorizSize :=
              TPointSeries(lSeriesP).Pointer.HorizSize + HIGHLIGHT_PSIZE;
            TPointSeries(lSeriesP).Pointer.VertSize :=
              TPointSeries(lSeriesP).Pointer.VertSize + HIGHLIGHT_PSIZE;
          end;
        FAntClickedIndex := lClickedIndex;
      end;
    end;
  end
  else
//  if (FAntClickedIndex > -1) then
  begin
//    formTimer.ShowTimerWindow(IntToStr(FAntClickedIndex),500);
    ClearHighlightedSeries(lChart);
  end;
end;

procedure TForm1.ClearHighlightedSeries(aChart: TDBChart);
var
  lSeries: TChartSeries;
  i,j: integer;
  lLineSeries: TLineSeries;
  lPointSeries: TPointSeries;
  LChart: TDBChart;

begin
  LChart := DBChart1;
  for i := 0 to DBChart1.SeriesCount - 1 do
  begin
    lSeries := aChart.Series[i];
    if (lSeries is TFastLineSeries) then
    begin
      lLineSeries := TLineSeries(lSeries);
      if i = FSavedIndexL then
        lLineSeries.Pen.Width := FSavedWidth;
      if fSuppressDups then
        for j := 1 to fNDep - 1 do
          if (i = FSavedIndexL + 3*j) then
            lLineSeries.Pen.Width := FSavedWidth;
    end;
    if (lSeries is TPointSeries) then
    begin
      lPointSeries := TPointSeries(lSeries);
      if (i = FSavedIndexP) then
      begin
        lPointSeries.Pointer.HorizSize := FSavedHorizSize;
        lPointSeries.Pointer.VertSize := FSavedVertSize;
      end;
      if fSuppressDups then
        for j := 1 to fNDep - 1 do
          if (i = FSavedIndexP + 3*j) then
          begin
            lPointSeries.Pointer.HorizSize := FSavedHorizSize;
            lPointSeries.Pointer.VertSize := FSavedVertSize;
          end;
    end;

  end;

  FAntClickedIndex := -1;
end;

Function TForm1.RGBA(const r,g,b,a:Integer):TColor;
begin
  {$IFDEF FMX}
  TAlphaColorRec(result).A:=a;
  TAlphaColorRec(result).R:=r;
  TAlphaColorRec(result).G:=g;
  TAlphaColorRec(result).B:=b;
  {$ELSE}
  result := (r or (g shl 8) or (b shl 16) or (a shl 24));
  {$ENDIF}
end;

procedure TForm1.SuppressDups(Sender: TObject);
begin
  fSuppressDups := not fSuppressDups;
  if fSuppressDups then
    Speedbutton3.Caption := 'Show all series in legend'
  else
    Speedbutton3.Caption := 'Hide duplicate series in legend';
  ClearData(Sender);
  LoadData(Sender);
end;

procedure TForm1.UndockGraph(Sender: TObject);
begin
  formChart.Visible := True;
  DBChart1.ManualDock(formChart,nil,alTop);
end;

end.
